﻿@using Business.Repository.IRepository
@using Models.CompetitionData
@using Models.TeamData
@inject IModalDialogService ModalDialog
@inject IJSRuntime JsRuntime
@inject ICompetitionTeamRepository CompetitionTeamRepository
@inject ICompetitionRepository CompetitionRepository
@inject ITeamSeasonRepository TeamSeasonRepository
@inject NavigationManager NavigationManager
@inject Blazored.LocalStorage.ILocalStorageService localStorage

<div class="row mt-2 mb-5">
    <div class="col-md-12">
        <div class="card">
            <div class="card-body">
                <EditForm Model="@CompetitionTeamModel" OnValidSubmit="HandleCreateUpdate">
                    <DataAnnotationsValidator />
                    @*<ValidationSummary />*@
                    <div class="form-group">
                        <label>Competition</label>
                        <InputText @bind-Value="CurrentCompetition.Name" class="form-control" disabled="true"></InputText>
                    </div>
                    <div class="form-group">
                        <label>Team</label>
                        <select class="form-select" @bind="selectedTeamId">
                            <option value="-1">--select--</option>
                            @foreach (var item in TeamSeasons.Where(x => !TeamsAlreadySelected.Any(y => y.TeamId == x.TeamId)))
                            {
                                <option class="p-3" value="@item.TeamId">@item.Team.Name</option>
                            }
                        </select>
                    </div>
                    <div class="form-group">
                        <button class="btn btn-primary">@Title</button>
                    </div>
                </EditForm>
            </div>
        </div>
    </div>
</div>

@code {
    [Parameter]
    public int? CompetitionTeamId { get; set; }
    [Parameter]
    public int? CompetitionId { get; set; }
    [Parameter]
    public IEnumerable<TeamSeasonDTO> TeamSeasons { get; set; }
    [CascadingParameter]
    BlazoredModalInstance ModalInstance { get; set; }


    private CompetitionTeamDTO CompetitionTeamModel { get; set; } = new CompetitionTeamDTO();
    private List<TeamDTO> TeamsForSelect { get; set; } = new List<TeamDTO>();
    private IEnumerable<CompetitionTeamDTO> TeamsAlreadySelected { get; set; } = new List<CompetitionTeamDTO>();
    private string Title { get; set; } = "Add";
    private CompetitionDTO CurrentCompetition { get; set; } = new CompetitionDTO();
    private int selectedTeamId { get; set; }

    protected override async Task OnInitializedAsync()
    {
        CurrentCompetition = await CompetitionRepository.Get(CompetitionId.Value);
        TeamsAlreadySelected = await CompetitionTeamRepository.GetAllFromCompetition(CompetitionId.Value);

    }
    private async Task HandleCreateUpdate()
    {
        try
        {
            //create
            CompetitionTeamModel.CompetitionId = CurrentCompetition.Id;
            CompetitionTeamModel.TeamId = selectedTeamId;

            var createdResult = await CompetitionTeamRepository.Create(CompetitionTeamModel);

            await JsRuntime.ToastrSuccess("Team added successfully to competition");
            await Task.Delay(300);
            ModalDialogParameters returnParameters = new ModalDialogParameters();
            ModalDialog.Close(true, returnParameters);
        }
        catch (Exception ex)
        {
            throw ex;

        }
    }
}
